Index: /LMDZ5/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 2158)
+++ /LMDZ5/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 2159)
@@ -174,4 +174,9 @@
        rain_f,    snow_f,    solsw_m,  sollw_m,       &
        t,         q,         u,        v,             &
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+!!       t_x,       q_x,       t_w,      q_w,           &
+       wake_dlt,             wake_dlq,                &
+       wake_cstar,           wake_s,                  &
+!!!
        pplay,     paprs,     pctsrf,                  &
        ts,        alb1, alb2,ustar, u10m, v10m,wstar, &
@@ -181,6 +186,20 @@
        zxtsol,    zxfluxlat, zt2m,     qsat2m,        &
        d_t,       d_q,       d_u,      d_v, d_t_diss, & 
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+       d_t_w,     d_q_w,                              &
+       d_t_x,     d_q_x,                              & 
+!!       d_wake_dlt,d_wake_dlq,                         &
+       zxsens_x,  zxfluxlat_x,zxsens_w,zxfluxlat_w,   &
+!!!
+!!! nrlmd le 13/06/2011
+       delta_tsurf,wake_dens,cdragh_x,cdragh_w,       &
+       cdragm_x,cdragm_w,kh,kh_x,kh_w,                &
+!!!
        zcoefh,    zcoefm,    slab_wfbils,             &
        qsol_d,    zq2m,      s_pblh,   s_plcl,        &
+!!!
+!!! jyg le 08/02/2012
+       s_pblh_x, s_plcl_x,   s_pblh_w, s_plcl_w,      &
+!!!
        s_capCL,   s_oliqCL,  s_cteiCL, s_pblT,        &
        s_therm,   s_trmb1,   s_trmb2,  s_trmb3,       &
@@ -191,5 +210,10 @@
        wfbils,    wfbilo,    flux_t,   flux_u, flux_v,&
        dflux_t,   dflux_q,   zxsnow,                  &
-       zxfluxt,   zxfluxq,   q2m,      flux_q, tke    )
+       zxfluxt,   zxfluxq,   q2m,      flux_q, tke,   &
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+!!        tke_x,     tke_w                              &
+       wake_dltke                                     &
+!!!
+                        )
 !****************************************************************************************
 ! Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
@@ -221,4 +245,8 @@
 ! u--------input-R- vitesse u
 ! v--------input-R- vitesse v
+! wake_dlt-input-R- temperatre difference between (w) and (x) (K)
+! wake_dlq-input-R- humidity difference between (w) and (x) (kg/kg)
+!wake_cstar-input-R- wake gust front speed (m/s)
+! wake_s---input-R- wake fractionnal area
 ! ts-------input-R- temperature du sol (en Kelvin)
 ! paprs----input-R- pression a intercouche (Pa)
@@ -240,4 +268,5 @@
 !                    (orientation positive vers le bas)
 ! tke---input/output-R- tke (kg/m**2/s)
+! wake_dltke-input/output-R- tke difference between (w) and (x) (kg/m**2/s)
 ! flux_q---output-R- flux de vapeur d'eau (kg/m**2/s)
 ! flux_u---output-R- tension du vent X: (kg m/s)/(m**2 s) ou Pascal
@@ -299,7 +328,21 @@
 ! Martin
 
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+!!    REAL, DIMENSION(klon,klev),   INTENT(IN)        :: t_x       ! Température hors poche froide
+!!    REAL, DIMENSION(klon,klev),   INTENT(IN)        :: t_w       ! Température dans la poches froide
+!!    REAL, DIMENSION(klon,klev),   INTENT(IN)        :: q_x       ! 
+!!    REAL, DIMENSION(klon,klev),   INTENT(IN)        :: q_w       ! Pareil pour l'humidité
+    REAL, DIMENSION(klon,klev),   INTENT(IN)        :: wake_dlt  !temperature difference between (w) and (x) (K)
+    REAL, DIMENSION(klon,klev),   INTENT(IN)        :: wake_dlq  !humidity difference between (w) and (x) (K)
+    REAL, DIMENSION(klon),        INTENT(IN)        :: wake_s    ! Fraction de poches froides
+    REAL, DIMENSION(klon),        INTENT(IN)        :: wake_cstar! Vitesse d'expansion des poches froides
+    REAL, DIMENSION(klon),        INTENT(IN)        :: wake_dens
+!!!
+
 ! Input/Output variables
 !****************************************************************************************
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: ts      ! temperature at surface (K)
+    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: delta_tsurf !surface temperature difference between
+                                                                   !wake and off-wake regions
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb1    ! albedo in visible SW interval
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb2    ! albedo in near infra-red SW interval
@@ -309,4 +352,9 @@
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: v10m    ! v speed at 10m
     REAL, DIMENSION(klon, klev+1, nbsrf+1), INTENT(INOUT) :: tke 
+
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+    REAL, DIMENSION(klon, klev+1, nbsrf), INTENT(INOUT) :: wake_dltke ! TKE_w - TKE_x
+!!!
+
 ! Output variables
 !****************************************************************************************
@@ -325,4 +373,10 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zxevap     ! water vapour flux at surface, positiv upwards
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zxtsol     ! temperature at surface, mean for each grid point
+!!! jyg le ???
+    REAL, DIMENSION(klon,klev),   INTENT(OUT)       :: d_t_w      !   !
+    REAL, DIMENSION(klon,klev),   INTENT(OUT)       :: d_q_w      !      !  Tendances dans les poches
+    REAL, DIMENSION(klon,klev),   INTENT(OUT)       :: d_t_x      !   !
+    REAL, DIMENSION(klon,klev),   INTENT(OUT)       :: d_q_x      !      !  Tendances hors des poches
+!!! jyg
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zxfluxlat  ! latent flux, mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zt2m       ! temperature at 2m, mean for each grid point
@@ -340,10 +394,34 @@
     ! coef for turbulent diffusion of U and V (?), mean for each grid point
 
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: zxsens_x   ! Flux sensible hors poche
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: zxsens_w   ! Flux sensible dans la poche
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: zxfluxlat_x! Flux latent hors poche
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: zxfluxlat_w! Flux latent dans la poche
+!!    REAL, DIMENSION(klon,klev),   INTENT(OUT)       :: d_wake_dlt
+!!    REAL, DIMENSION(klon,klev),   INTENT(OUT)       :: d_wake_dlq
+
 ! Output only for diagnostics
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: cdragh_x
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: cdragh_w
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: cdragm_x
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: cdragm_w
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: kh
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: kh_x
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: kh_w
+!!! 
     REAL, DIMENSION(klon),        INTENT(OUT)       :: slab_wfbils! heat balance at surface only for slab at ocean points
     REAL, DIMENSION(klon),        INTENT(OUT)       :: qsol_d     ! water height in the soil (mm)
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zq2m       ! water vapour at 2m, mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: s_pblh     ! height of the planetary boundary layer(HPBL)
+!!! jyg le 08/02/2012
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: s_pblh_x   ! height of the PBL in the off-wake region
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: s_pblh_w   ! height of the PBL in the wake region
+!!!
     REAL, DIMENSION(klon),        INTENT(OUT)       :: s_plcl     ! condensation level
+!!! jyg le 08/02/2012
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: s_plcl_x   ! condensation level in the off-wake region
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: s_plcl_w   ! condensation level in the wake region
+!!!
     REAL, DIMENSION(klon),        INTENT(OUT)       :: s_capCL    ! CAPE of PBL
     REAL, DIMENSION(klon),        INTENT(OUT)       :: s_oliqCL   ! liquid water intergral of PBL
@@ -409,8 +487,10 @@
 ! Other local variables
 !****************************************************************************************
+    INTEGER                            :: iflag_split 
     INTEGER                            :: i, k, nsrf 
     INTEGER                            :: knon, j
     INTEGER                            :: idayref
     INTEGER , DIMENSION(klon)          :: ni
+    REAL                               :: yt1_new
     REAL                               :: zx_alf1, zx_alf2 !valeur ambiante par extrapola
     REAL                               :: amn, amx
@@ -419,5 +499,5 @@
     REAL, DIMENSION(klon)              :: yts, yrugos, ypct, yz0_new
     REAL, DIMENSION(klon)              :: yalb, yalb1, yalb2
-    REAL, DIMENSION(klon)              :: yu1, yv1,ytoto
+    REAL, DIMENSION(klon)              :: yu1, yv1
     REAL, DIMENSION(klon)              :: ysnow, yqsurf, yagesno, yqsol
     REAL, DIMENSION(klon)              :: yrain_f, ysnow_f
@@ -474,6 +554,192 @@
     LOGICAL, PARAMETER                 :: zxli=.FALSE. ! utiliser un jeu de fonctions simples
     LOGICAL, PARAMETER                 :: check=.FALSE.
-    REAL, DIMENSION(klon)              :: Kech_h       ! Coefficient d'echange pour l'energie
+
+!!! nrlmd le 02/05/2011
+!!! jyg le 07/02/2012
+    REAL, DIMENSION(klon)              :: ywake_s, ywake_cstar, ywake_dens
+!!!
+    REAL, DIMENSION(klon,klev+1)       :: ytke_x, ytke_w
+    REAL, DIMENSION(klon,klev+1)       :: ywake_dltke
+    REAL, DIMENSION(klon,klev)         :: yu_x, yv_x, yu_w, yv_w
+    REAL, DIMENSION(klon,klev)         :: yt_x, yq_x, yt_w, yq_w
+    REAL, DIMENSION(klon,klev)         :: ycoefh_x, ycoefm_x, ycoefh_w, ycoefm_w
+    REAL, DIMENSION(klon,klev)         :: ycoefq_x, ycoefq_w
+    REAL, DIMENSION(klon)              :: ycdragh_x, ycdragm_x, ycdragh_w, ycdragm_w
+    REAL, DIMENSION(klon)              :: AcoefH_x, AcoefQ_x, BcoefH_x, BcoefQ_x
+    REAL, DIMENSION(klon)              :: AcoefH_w, AcoefQ_w, BcoefH_w, BcoefQ_w
+    REAL, DIMENSION(klon)              :: AcoefU_x, AcoefV_x, BcoefU_x, BcoefV_x
+    REAL, DIMENSION(klon)              :: AcoefU_w, AcoefV_w, BcoefU_w, BcoefV_w
+    REAL, DIMENSION(klon)              :: y_flux_t1_x, y_flux_q1_x, y_flux_t1_w, y_flux_q1_w
+    REAL, DIMENSION(klon)              :: y_flux_u1_x, y_flux_v1_x, y_flux_u1_w, y_flux_v1_w
+    REAL, DIMENSION(klon,klev)         :: y_flux_t_x, y_flux_q_x, y_flux_t_w, y_flux_q_w
+    REAL, DIMENSION(klon,klev)         :: y_flux_u_x, y_flux_v_x, y_flux_u_w, y_flux_v_w
+    REAL, DIMENSION(klon)              :: yfluxlat_x, yfluxlat_w
+    REAL, DIMENSION(klon,klev)         :: y_d_t_x, y_d_q_x, y_d_t_w, y_d_q_w
+    REAL, DIMENSION(klon,klev)         :: y_d_t_diss_x, y_d_t_diss_w
+    REAL, DIMENSION(klon,klev)         :: d_t_diss_x, d_t_diss_w
+    REAL, DIMENSION(klon,klev)         :: y_d_u_x, y_d_v_x, y_d_u_w, y_d_v_w
+    REAL, DIMENSION(klon, klev, nbsrf) :: flux_t_x, flux_q_x, flux_t_w, flux_q_w
+    REAL, DIMENSION(klon, klev, nbsrf) :: flux_u_x, flux_v_x, flux_u_w, flux_v_w
+    REAL, DIMENSION(klon, nbsrf)       :: fluxlat_x, fluxlat_w
+    REAL, DIMENSION(klon, klev)        :: zxfluxt_x, zxfluxq_x, zxfluxt_w, zxfluxq_w
+    REAL, DIMENSION(klon, klev)        :: zxfluxu_x, zxfluxv_x, zxfluxu_w, zxfluxv_w
+    REAL                               :: zx_qs_surf, zcor_surf, zdelta_surf
+    REAL, DIMENSION(klon)              :: ytsurf_th, yqsatsurf
+    REAL, DIMENSION(klon)              :: ybeta
+    REAL, DIMENSION(klon, klev)        :: d_u_x
+    REAL, DIMENSION(klon, klev)        :: d_u_w
+    REAL, DIMENSION(klon, klev)        :: d_v_x
+    REAL, DIMENSION(klon, klev)        :: d_v_w 
+
+    REAL, DIMENSION(klon,klev)         :: CcoefH, CcoefQ, DcoefH, DcoefQ
+    REAL, DIMENSION(klon,klev)         :: CcoefU, CcoefV, DcoefU, DcoefV
+    REAL, DIMENSION(klon,klev)         :: CcoefH_x, CcoefQ_x, DcoefH_x, DcoefQ_x
+    REAL, DIMENSION(klon,klev)         :: CcoefH_w, CcoefQ_w, DcoefH_w, DcoefQ_w
+    REAL, DIMENSION(klon,klev)         :: CcoefU_x, CcoefV_x, DcoefU_x, DcoefV_x
+    REAL, DIMENSION(klon,klev)         :: CcoefU_w, CcoefV_w, DcoefU_w, DcoefV_w
+    REAL, DIMENSION(klon,klev)         :: Kcoef_hq, Kcoef_m, gama_h, gama_q
+    REAL, DIMENSION(klon,klev)         :: Kcoef_hq_x, Kcoef_m_x, gama_h_x, gama_q_x
+    REAL, DIMENSION(klon,klev)         :: Kcoef_hq_w, Kcoef_m_w, gama_h_w, gama_q_w
+    REAL, DIMENSION(klon)              :: alf_1, alf_2, alf_1_x, alf_2_x, alf_1_w, alf_2_w
+!!!
+!!!jyg le 08/02/2012
+    REAL, DIMENSION(klon, nbsrf)       :: t2m_x
+    REAL, DIMENSION(klon, nbsrf)       :: q2m_x
+    REAL, DIMENSION(klon)              :: rh2m_x
+    REAL, DIMENSION(klon)              :: qsat2m_x
+    REAL, DIMENSION(klon, nbsrf)       :: u10m_x
+    REAL, DIMENSION(klon, nbsrf)       :: v10m_x
+    REAL, DIMENSION(klon, nbsrf)       :: ustar_x
+    REAL, DIMENSION(klon, nbsrf)       :: wstar_x
+!              
+    REAL, DIMENSION(klon, nbsrf)       :: pblh_x
+    REAL, DIMENSION(klon, nbsrf)       :: plcl_x
+    REAL, DIMENSION(klon, nbsrf)       :: capCL_x
+    REAL, DIMENSION(klon, nbsrf)       :: oliqCL_x
+    REAL, DIMENSION(klon, nbsrf)       :: cteiCL_x
+    REAL, DIMENSION(klon, nbsrf)       :: pblt_x
+    REAL, DIMENSION(klon, nbsrf)       :: therm_x
+    REAL, DIMENSION(klon, nbsrf)       :: trmb1_x
+    REAL, DIMENSION(klon, nbsrf)       :: trmb2_x
+    REAL, DIMENSION(klon, nbsrf)       :: trmb3_x
+!
+    REAL, DIMENSION(klon, nbsrf)       :: t2m_w
+    REAL, DIMENSION(klon, nbsrf)       :: q2m_w
+    REAL, DIMENSION(klon)              :: rh2m_w
+    REAL, DIMENSION(klon)              :: qsat2m_w
+    REAL, DIMENSION(klon, nbsrf)       :: u10m_w
+    REAL, DIMENSION(klon, nbsrf)       :: v10m_w
+    REAL, DIMENSION(klon, nbsrf)       :: ustar_w
+    REAL, DIMENSION(klon, nbsrf)       :: wstar_w
+!                           
+    REAL, DIMENSION(klon, nbsrf)       :: pblh_w
+    REAL, DIMENSION(klon, nbsrf)       :: plcl_w
+    REAL, DIMENSION(klon, nbsrf)       :: capCL_w
+    REAL, DIMENSION(klon, nbsrf)       :: oliqCL_w
+    REAL, DIMENSION(klon, nbsrf)       :: cteiCL_w
+    REAL, DIMENSION(klon, nbsrf)       :: pblt_w
+    REAL, DIMENSION(klon, nbsrf)       :: therm_w
+    REAL, DIMENSION(klon, nbsrf)       :: trmb1_w
+    REAL, DIMENSION(klon, nbsrf)       :: trmb2_w
+    REAL, DIMENSION(klon, nbsrf)       :: trmb3_w
+!
+    REAL, DIMENSION(klon)       :: yt2m_x
+    REAL, DIMENSION(klon)       :: yq2m_x
+    REAL, DIMENSION(klon)       :: yt10m_x
+    REAL, DIMENSION(klon)       :: yq10m_x
+    REAL, DIMENSION(klon)       :: yu10m_x
+    REAL, DIMENSION(klon)       :: yv10m_x
+    REAL, DIMENSION(klon)       :: yustar_x
+    REAL, DIMENSION(klon)       :: ywstar_x
+!              
+    REAL, DIMENSION(klon)       :: ypblh_x
+    REAL, DIMENSION(klon)       :: ylcl_x
+    REAL, DIMENSION(klon)       :: ycapCL_x
+    REAL, DIMENSION(klon)       :: yoliqCL_x
+    REAL, DIMENSION(klon)       :: ycteiCL_x
+    REAL, DIMENSION(klon)       :: ypblt_x
+    REAL, DIMENSION(klon)       :: ytherm_x
+    REAL, DIMENSION(klon)       :: ytrmb1_x
+    REAL, DIMENSION(klon)       :: ytrmb2_x
+    REAL, DIMENSION(klon)       :: ytrmb3_x
+!
+    REAL, DIMENSION(klon)       :: yt2m_w
+    REAL, DIMENSION(klon)       :: yq2m_w
+    REAL, DIMENSION(klon)       :: yt10m_w
+    REAL, DIMENSION(klon)       :: yq10m_w
+    REAL, DIMENSION(klon)       :: yu10m_w
+    REAL, DIMENSION(klon)       :: yv10m_w
+    REAL, DIMENSION(klon)       :: yustar_w
+    REAL, DIMENSION(klon)       :: ywstar_w
+!                       
+    REAL, DIMENSION(klon)       :: ypblh_w
+    REAL, DIMENSION(klon)       :: ylcl_w
+    REAL, DIMENSION(klon)       :: ycapCL_w
+    REAL, DIMENSION(klon)       :: yoliqCL_w
+    REAL, DIMENSION(klon)       :: ycteiCL_w
+    REAL, DIMENSION(klon)       :: ypblt_w
+    REAL, DIMENSION(klon)       :: ytherm_w
+    REAL, DIMENSION(klon)       :: ytrmb1_w
+    REAL, DIMENSION(klon)       :: ytrmb2_w
+    REAL, DIMENSION(klon)       :: ytrmb3_w
+!
+    REAL, DIMENSION(klon)              :: uzon_x, vmer_x
+    REAL, DIMENSION(klon)              :: zgeo1_x, tair1_x, qair1_x, tairsol_x
+!
+    REAL, DIMENSION(klon)              :: uzon_w, vmer_w
+    REAL, DIMENSION(klon)              :: zgeo1_w, tair1_w, qair1_w, tairsol_w
+
+!!! jyg le 25/03/2013
+!!    Variables intermediaires pour le raccord des deux colonnes à la surface
+    REAL   ::   dd_Ch
+    REAL   ::   dd_Cm
+    REAL   ::   dd_Kh
+    REAL   ::   dd_Km
+    REAL   ::   dd_u 
+    REAL   ::   dd_v 
+    REAL   ::   dd_t 
+    REAL   ::   dd_q 
+    REAL   ::   dd_AH
+    REAL   ::   dd_AQ
+    REAL   ::   dd_AU
+    REAL   ::   dd_AV
+    REAL   ::   dd_BH
+    REAL   ::   dd_BQ
+    REAL   ::   dd_BU
+    REAL   ::   dd_BV
+
+    REAL   ::   dd_KHp
+    REAL   ::   dd_KQp
+    REAL   ::   dd_KUp
+    REAL   ::   dd_KVp
+
+!!!
+!!! nrlmd le 13/06/2011
+    REAL, DIMENSION(klon)              :: y_delta_flux_t1, y_delta_flux_q1, y_delta_flux_u1, y_delta_flux_v1
+    REAL, DIMENSION(klon)              :: y_delta_tsurf,delta_coef,tau_eq
+    REAL, PARAMETER                    :: facteur=2./sqrt(3.14)
+    REAL, PARAMETER                    :: effusivity=2000.
+    REAL, DIMENSION(klon)              :: ytsurf_th_x,ytsurf_th_w,yqsatsurf_x,yqsatsurf_w
+    REAL, DIMENSION(klon)              :: ydtsurf_th
+    REAL                               :: zdelta_surf_x,zdelta_surf_w,zx_qs_surf_x,zx_qs_surf_w
+    REAL                               :: zcor_surf_x,zcor_surf_w
+    REAL                               :: mod_wind_x, mod_wind_w
+    REAL                               :: rho1
+    REAL, DIMENSION(klon)              :: Kech_h           ! Coefficient d'echange pour l'energie
+    REAL, DIMENSION(klon)              :: Kech_h_x, Kech_h_w 
+    REAL, DIMENSION(klon)              :: Kech_m
+    REAL, DIMENSION(klon)              :: Kech_m_x, Kech_m_w 
+    REAL, DIMENSION(klon)              :: yts_x,yts_w
+    REAL, DIMENSION(klon)              :: Kech_Hp, Kech_H_xp, Kech_H_wp
+    REAL, DIMENSION(klon)              :: Kech_Qp, Kech_Q_xp, Kech_Q_wp
+    REAL, DIMENSION(klon)              :: Kech_Up, Kech_U_xp, Kech_U_wp
+    REAL, DIMENSION(klon)              :: Kech_Vp, Kech_V_xp, Kech_V_wp
+
     REAL                               :: vent
+
+
+
+
+!!!
 
 ! For debugging with IOIPSL
@@ -514,8 +780,10 @@
 
 !****************************************************************************************
-
 ! End of declarations
 !****************************************************************************************
 
+      IF (prt_level >=10) print *,' -> pbl_surface, itap ',itap
+!
+      iflag_split = mod(iflag_pbl_split,2)
 
 !****************************************************************************************
@@ -594,5 +862,26 @@
     ypphi = 0.0   ; ycldt = 0.0      ; yrmu0 = 0.0
     ! Martin
-    
+
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+    ytke_x=0.     ; ytke_w=0.        ; ywake_dltke=0.
+    y_d_t_x=0.    ; y_d_t_w=0.       ; y_d_q_x=0.      ; y_d_q_w=0.
+    d_t_w=0.      ; d_q_w=0.         
+    d_t_x=0.      ; d_q_x=0.
+    d_t_diss_x = 0. ; d_t_diss_w = 0.
+!!    d_wake_dlt=0.    ; d_wake_dlq=0.
+    d_u_x=0.      ; d_u_w=0.         ; d_v_x=0.        ; d_v_w=0.
+    flux_t_x=0.   ; flux_t_w=0.      ; flux_q_x=0.     ; flux_q_w=0.
+    yfluxlat_x=0. ; yfluxlat_w=0.
+    ywake_s=0.    ; ywake_cstar=0.   ;ywake_dens=0.
+!!!
+!!! nrlmd le 13/06/2011
+    tau_eq=0.     ; delta_coef=0.
+    y_delta_flux_t1=0.
+    ydtsurf_th=0.
+    yts_x=0.      ; yts_w=0.
+    y_delta_tsurf=0.
+    cdragh_x=0.   ; cdragh_w=0.      ; cdragm_x=0.     ;cdragm_w=0.
+    kh=0.         ; kh_x=0.          ; kh_w=0.
+!!!
     tke(:,:,is_ave)=0.
     IF (iflag_pbl<20.or.iflag_pbl>=30) THEN
@@ -607,6 +896,27 @@
     ytsoil = 999999. 
 
+!!! jyg le 23/02/2013
+    pblh(:,:)      = 999999.     ! pblh,plcl,cteiCL are meaningfull only over sub-surfaces
+    plcl(:,:)      = 999999.     ! actually present in the grid cell.
+    cteiCL(:,:)    = 999999.
+    pblh_x(:,:)      = 999999.  
+    plcl_x(:,:)      = 999999.  
+    cteiCL_x(:,:)    = 999999.  
+    pblh_w(:,:)      = 999999.   
+    plcl_w(:,:)      = 999999.   
+    cteiCL_w(:,:)    = 999999.   
+!
+    t2m(:,:)       = 999999.     ! t2m and q2m are meaningfull only over sub-surfaces
+    q2m(:,:)       = 999999.     ! actually present in the grid cell.
+!!!
     rh2m(:)        = 0.
     qsat2m(:)      = 0.
+!!!
+!!! jyg le 10/02/2012
+    rh2m_x(:)        = 0.
+    qsat2m_x(:)      = 0.
+    rh2m_w(:)        = 0.
+    qsat2m_w(:)      = 0.
+!!!
 !****************************************************************************************
 ! 3) - Calculate pressure thickness of each layer
@@ -699,9 +1009,10 @@
 ! 4) Loop over different surfaces
 !
-! Only points containing a fraction of the sub surface will be threated.
+! Only points containing a fraction of the sub surface will be treated.
 ! 
 !****************************************************************************************
    
     loop_nbsrf: DO nsrf = 1, nbsrf
+       IF (prt_level >=10) print *,' Loop nsrf ',nsrf
 
 ! Search for index(ni) and size(knon) of domaine to treat
@@ -714,4 +1025,11 @@
           ENDIF
        ENDDO
+
+!!! jyg le 19/08/2012
+       IF (knon <= 0) THEN
+         IF (prt_level >= 10) print *,' no grid point for nsrf= ',nsrf
+         cycle loop_nbsrf
+       ENDIF
+!!!
 
        ! write index, with IOIPSL
@@ -758,4 +1076,7 @@
           yrmu0(j)   = rmu0(i)
           ! Martin
+!!! nrlmd le 13/06/2011
+          y_delta_tsurf(j)=delta_tsurf(i,nsrf)
+!!!
        END DO
 
@@ -766,4 +1087,10 @@
              ypplay(j,k) = pplay(i,k)
              ydelp(j,k)  = delp(i,k)
+          ENDDO
+       ENDDO
+!!! jyg le 07/02/2012 et le 10/04/2013
+        DO k = 1, klev
+          DO j = 1, knon
+             i = ni(j)
              ytke(j,k)   = tke(i,k,nsrf)
              yu(j,k) = u(i,k)
@@ -772,6 +1099,49 @@
              yq(j,k) = q(i,k)
           ENDDO
-       ENDDO
-
+        ENDDO
+!
+       IF (iflag_split .eq.1) THEN
+!!! nrlmd le 02/05/2011
+        DO k = 1, klev
+          DO j = 1, knon
+             i = ni(j)
+             yu_x(j,k) = u(i,k)
+             yv_x(j,k) = v(i,k)
+             yt_x(j,k) = t(i,k)-wake_s(i)*wake_dlt(i,k)
+             yq_x(j,k) = q(i,k)-wake_s(i)*wake_dlq(i,k)
+             yu_w(j,k) = u(i,k)
+             yv_w(j,k) = v(i,k)
+             yt_w(j,k) = t(i,k)+(1.-wake_s(i))*wake_dlt(i,k)
+             yq_w(j,k) = q(i,k)+(1.-wake_s(i))*wake_dlq(i,k)
+!!!
+          ENDDO
+        ENDDO
+!!! nrlmd le 02/05/2011
+        DO k = 1, klev+1
+          DO j = 1, knon
+             i = ni(j)
+             ytke_x(j,k) = tke(i,k,nsrf)-wake_s(i)*wake_dltke(i,k,nsrf)
+             ytke_w(j,k) = tke(i,k,nsrf)+(1.-wake_s(i))*wake_dltke(i,k,nsrf)
+             ywake_dltke(j,k) = wake_dltke(i,k,nsrf)
+             ytke(j,k)     = tke(i,k,nsrf)
+          ENDDO
+        ENDDO
+!!!
+!!! jyg le 07/02/2012
+        DO j = 1, knon
+          i = ni(j)
+          ywake_s(j)=wake_s(i)
+          ywake_cstar(j)=wake_cstar(i)
+          ywake_dens(j)=wake_dens(i)
+        ENDDO
+!!!
+!!! nrlmd le 13/06/2011
+        DO j=1,knon
+         yts_x(j)=yts(j)-ywake_s(j)*y_delta_tsurf(j)
+         yts_w(j)=yts(j)+(1.-ywake_s(j))*y_delta_tsurf(j)
+        ENDDO
+!!!
+       ENDIF  ! (iflag_split .eq.1)
+!!!
        DO k = 1, nsoilmx
           DO j = 1, knon
@@ -794,5 +1164,9 @@
 !****************************************************************************************
 
-       CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+!!!
+!!! nrlmd & jyg les 02/05/2011, 13/06/2011, 05/02/2012
+        CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
             yu(:,1), yv(:,1), yt(:,1), yq(:,1), &
             yts, yqsurf, yrugos, &
@@ -810,15 +1184,64 @@
       ENDDO
      ENDIF
-
-
-!****************************************************************************************
-! 6b) Calculate coefficients for turbulent diffusion in the atmosphere, ycoefm et ycoefm.
-!
-!****************************************************************************************
-
-       CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
+        IF (prt_level >=10) print *,'clcdrag -> ycdragh ', ycdragh
+       ELSE  !(iflag_split .eq.0)
+        CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
+            yu_x(:,1), yv_x(:,1), yt_x(:,1), yq_x(:,1), &
+            yts_x, yqsurf, yrugos, &
+            ycdragm_x, ycdragh_x )
+! --- special Dice. JYG+MPL 25112013
+        IF (ok_prescr_ust) then
+         DO i = 1, knon
+          print *,'ycdragm_x avant=',ycdragm_x(i)
+          vent= sqrt(yu_x(i,1)*yu_x(i,1)+yv_x(i,1)*yv_x(i,1))
+          ycdragm_x(i) = ust*ust/(1.+vent)/vent
+          print *,'ycdragm_x ust yu yv apres=',ycdragm_x(i),ust,yu_x(i,1),yv_x(i,1)
+         ENDDO
+        ENDIF
+        IF (prt_level >=10) print *,'clcdrag -> ycdragh_x ', ycdragh_x
+!
+        CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
+            yu_w(:,1), yv_w(:,1), yt_w(:,1), yq_w(:,1), &
+            yts_w, yqsurf, yrugos, &
+            ycdragm_w, ycdragh_w )
+! --- special Dice. JYG+MPL 25112013
+        IF (ok_prescr_ust) then
+         DO i = 1, knon
+          print *,'ycdragm_w avant=',ycdragm_w(i)
+          vent= sqrt(yu_w(i,1)*yu_w(i,1)+yv_w(i,1)*yv_w(i,1))
+          ycdragm_w(i) = ust*ust/(1.+vent)/vent
+          print *,'ycdragm_w ust yu yv apres=',ycdragm_w(i),ust,yu_w(i,1),yv_w(i,1)
+         ENDDO
+        ENDIF
+        IF (prt_level >=10) print *,'clcdrag -> ycdragh_w ', ycdragh_w
+!!!
+       ENDIF  ! (iflag_split .eq.0)
+!!!
+       
+
+!****************************************************************************************
+! 6b) Calculate coefficients for turbulent diffusion in the atmosphere, ycoefh et ycoefm.
+!
+!****************************************************************************************
+
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+!!!
+!!! nrlmd & jyg les 02/05/2011, 13/06/2011, 05/02/2012
+      IF (prt_level >=10) THEN
+      print *,' args coef_diff_turb: yu ',  yu  
+      print *,' args coef_diff_turb: yv ',  yv  
+      print *,' args coef_diff_turb: yq ',  yq  
+      print *,' args coef_diff_turb: yt ',  yt  
+      print *,' args coef_diff_turb: yts ', yts  
+      print *,' args coef_diff_turb: yrugos ', yrugos  
+      print *,' args coef_diff_turb: yqsurf ', yqsurf  
+      print *,' args coef_diff_turb: ycdragm ', ycdragm
+      print *,' args coef_diff_turb: ycdragh ', ycdragh
+      print *,' args coef_diff_turb: ytke ', ytke
+       ENDIF
+        CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
             ypaprs, ypplay, yu, yv, yq, yt, yts, yrugos, yqsurf, ycdragm, &
             ycoefm, ycoefh, ytke)
-
        IF (iflag_pbl>=20.AND.iflag_pbl<30) THEN
 ! In this case, coef_diff_turb is called for the Cd only
@@ -831,4 +1254,73 @@
        ENDDO
        ENDIF
+        IF (prt_level >=10) print *,'coef_diff_turb -> ycoefh ',ycoefh
+!
+       ELSE  !(iflag_split .eq.0)
+      IF (prt_level >=10) THEN
+      print *,' args coef_diff_turb: yu_x ',  yu_x  
+      print *,' args coef_diff_turb: yv_x ',  yv_x  
+      print *,' args coef_diff_turb: yq_x ',  yq_x  
+      print *,' args coef_diff_turb: yt_x ',  yt_x  
+      print *,' args coef_diff_turb: yts_x ', yts_x  
+      print *,' args coef_diff_turb: yrugos ', yrugos  
+      print *,' args coef_diff_turb: yqsurf ', yqsurf  
+      print *,' args coef_diff_turb: ycdragm_x ', ycdragm_x
+      print *,' args coef_diff_turb: ycdragh_x ', ycdragh_x
+      print *,' args coef_diff_turb: ytke_x ', ytke_x
+       ENDIF
+        CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
+            ypaprs, ypplay, yu_x, yv_x, yq_x, yt_x, yts_x, yrugos, yqsurf, ycdragm_x, &
+            ycoefm_x, ycoefh_x, ytke_x)
+       IF (iflag_pbl>=20.AND.iflag_pbl<30) THEN
+! In this case, coef_diff_turb is called for the Cd only
+       DO k = 2, klev
+          DO j = 1, knon
+             i = ni(j)
+             ycoefh_x(j,k)   = zcoefh(i,k,nsrf)
+             ycoefm_x(j,k)   = zcoefm(i,k,nsrf)
+          ENDDO
+       ENDDO
+       ENDIF
+        IF (prt_level >=10) print *,'coef_diff_turb -> ycoefh_x ',ycoefh_x
+!
+      IF (prt_level >=10) THEN
+      print *,' args coef_diff_turb: yu_w ',  yu_w  
+      print *,' args coef_diff_turb: yv_w ',  yv_w  
+      print *,' args coef_diff_turb: yq_w ',  yq_w  
+      print *,' args coef_diff_turb: yt_w ',  yt_w  
+      print *,' args coef_diff_turb: yts_w ', yts_w  
+      print *,' args coef_diff_turb: yrugos ', yrugos  
+      print *,' args coef_diff_turb: yqsurf ', yqsurf  
+      print *,' args coef_diff_turb: ycdragm_w ', ycdragm_w
+      print *,' args coef_diff_turb: ycdragh_w ', ycdragh_w
+      print *,' args coef_diff_turb: ytke_w ', ytke_w
+       ENDIF
+        CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
+            ypaprs, ypplay, yu_w, yv_w, yq_w, yt_w, yts_w, yrugos, yqsurf, ycdragm_w, &
+            ycoefm_w, ycoefh_w, ytke_w)
+       IF (iflag_pbl>=20.AND.iflag_pbl<30) THEN
+! In this case, coef_diff_turb is called for the Cd only
+       DO k = 2, klev
+          DO j = 1, knon
+             i = ni(j)
+             ycoefh_w(j,k)   = zcoefh(i,k,nsrf)
+             ycoefm_w(j,k)   = zcoefm(i,k,nsrf)
+          ENDDO
+       ENDDO
+       ENDIF
+        IF (prt_level >=10) print *,'coef_diff_turb -> ycoefh_w ',ycoefh_w
+!
+!!!jyg le 10/04/2013
+!!   En attendant de traiter le transport des traceurs dans les poches froides, formule
+!!   arbitraire pour ycoefh et ycoefm
+      DO k = 2,klev
+        DO j = 1,knon
+         ycoefh(j,k) = ycoefh_x(j,k) + ywake_s(j)*(ycoefh_w(j,k) - ycoefh_x(j,k))
+         ycoefm(j,k) = ycoefm_x(j,k) + ywake_s(j)*(ycoefm_w(j,k) - ycoefm_x(j,k))
+        ENDDO
+      ENDDO
+!!!
+       ENDIF  ! (iflag_split .eq.0)
+!!!
        
 !****************************************************************************************
